object Tree {
    def buildComplete[T](numLevels:Int)(f:Int=>T):Tree[T] = {
        def aux(numLevels:Int, i:Int):Tree[T] = {
            if (numLevels <= 0) E()
            else N(aux(numLevels-1, i+1),
                   f(i),
                   aux(numLevels-1, i+(1 << (numLevels-1))))
        }
        aux(numLevels,0)
    }
}

sealed abstract class Tree[T] {
    def count(p:T=>Boolean):Int = this match {
        case E() => 0
        case N(l,e,r) =>
            l.count(p) + r.count(p) +
                (if (p(e)) 1 else 0)
    }
    def countPar(p:T=>Boolean):Int = this match {
        case E() => 0
        case N(l,e,r) => {
            val (resl,resr) =
                Par.par(l.countPar(p))(r.countPar(p)) // <-- corretto nella lezione del 27/11/19
            resl + resr + (if (p(e)) 1 else 0)
        }
    }
}

case class E[T]() extends Tree[T]
case class N[T](l:Tree[T],e:T,r:Tree[T])
    extends Tree[T]
